## octave-control 4.1.1

=== DESCRIPTION ===
Name: control
Version: 4.1.1
Date: 2025-02-09
Author: Lukas Reichlin <lukas.reichlin@gmail.com>
Maintainer: Doug Stewart <doug.dastew@gmail.com>, Torsten Lilge <ttl-octave@mailbox.org>
Title: Control Package
Description: Control package for GNU Octave including system analysis and
 control synthesis. The package uses routines of the SLICOT-Reference library.
Depends: octave (>= 4.0.0)
Autoload: no
License: GPLv3-or-later, BSD 3-Clause License (SLICOT files)
Url: https://github.com/gnu-octave/pkg-control
Tracker: https://github.com/gnu-octave/pkg-control/issues

=== src/Makefile ===
-include ./Makefile.conf

MKOCTFILE ?= mkoctfile

ifndef LAPACK_LIBS
LAPACK_LIBS := $(shell $(MKOCTFILE) -p LAPACK_LIBS)
endif
ifndef BLAS_LIBS
BLAS_LIBS := $(shell $(MKOCTFILE) -p BLAS_LIBS)
endif
ifndef FLIBS
FLIBS := $(shell $(MKOCTFILE) -p FLIBS)
endif
LDFLAGS := $(shell $(MKOCTFILE) -p LDFLAGS) $(LAPACK_LIBS) $(BLAS_LIBS) $(FLIBS)

# slicot relative to src directory, SC_SRC is the build directory
SC      := slicot
SC_SRC  := $(SC)/src
SC_SMOD := ../slicot-reference

# own and auxilary sources relative to build directory
SRC := ../..
SRC_AUX := $(SRC)/src_aux

# other definitions
AR := $(shell $(MKOCTFILE) -p AR)

PKG_CXXFLAGS := -Wall $(PKG_CXXFLAGS_APPEND)

all: __control_slicot_functions__.oct \
     __control_helper_functions__.oct

# if directly called from repository instead of distributed file structure,
# copy required files into the slicot source directory.

# MA02ID.f : One exemplary file from SLICOT, if not present, other files
#            are most probably missing as well. Copy all files from the
#            src directories of the SLICOT submodule.
$(SC_SRC)/MA02ID.f:
	mkdir -p $(SC_SRC)
	cp $(SC_SMOD)/src/*.f $(SC_SRC)
	cp $(SC_SMOD)/src_aux/*.f $(SC_SRC)
	./bootstrap && $(RM) -r "autom4te.cache"

# TODO: Private oct-files for control package.

# Compile SLICOT library
#
# Compile: $(SC_SRC)/*.f   (SLICOT files)
#          ./TG04BX.f      own derived file
#          $(SRC_AUX)/*.f  external sources like deprecated
#                          LAPACK files
#
# MA02ID.f is compiled by an extra command
# suppressing warnings on indexing errors
#
slicotlibrary.a: slicot $(SC_SRC)/MA02ID.f
	cd $(SC_SRC) && \
	  $(MKOCTFILE) -w -c MA02ID.f; mv MA02ID.f x && \
		$(MKOCTFILE) -c *.f $(SRC)/TG04BX.f $(SRC_AUX)/*.f && \
		mv x MA02ID.f
	$(AR) -rc slicotlibrary.a $(SC_SRC)/*.o

# slicot functions
__control_slicot_functions__.oct: __control_slicot_functions__.cc common.cc slicotlibrary.a
	LDFLAGS="$(LDFLAGS)" \
    $(MKOCTFILE) $(PKG_CXXFLAGS) __control_slicot_functions__.cc common.cc slicotlibrary.a

# helper functions
__control_helper_functions__.oct: __control_helper_functions__.cc
	$(MKOCTFILE) $(PKG_CXXFLAGS) __control_helper_functions__.cc

clean:
	$(RM) -r *.o core octave-core *.oct *~ $(SC_SRC)/*.o
	$(RM) -rf $(SC_SRC)

realclean: clean
	$(RM) -r *.a

## This should also remove any configure cache which clean should not
## remove according to GNU guidelines.
## https://www.gnu.org/prep/standards/html_node/Standard-Targets.html
distclean: clean realclean
	rm -f Makefile.conf config.h config.log config.status oct-alt-includes.h

=== debian/changelog ===
octave-control (4.1.1-1) unstable; urgency=medium

  * New upstream version 4.1.1
  * d/copyright: reflect upstream changes
  * d/u/metadata: repository moved to GitHub
  * test-tolerance.patch: drop patch, applied upstream

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 14 Feb 2025 14:04:38 +0100

=== debian/control ===
Source: octave-control
Section: math
Priority: optional
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>,
           Rafael Laboissière <rafael@debian.org>,
           Mike Miller <mtmiller@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-octave (>= 1.2.3),
               dh-sequence-octave,
               libslicot-dev (>= 5.8)
Standards-Version: 4.7.0
Homepage: https://gnu-octave.github.io/packages/control/
Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-control.git
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-control
Testsuite: autopkgtest-pkg-octave
Rules-Requires-Root: no

Package: octave-control
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${octave:Depends}
Multi-Arch: same
Description: computer-aided control system design (CACSD) for Octave
 This package provides additional functions related to control theory
 in Octave, a numerical computation software. The functions are based on SLICOT
 Fortran library <http://www.slicot.org>.
 .
 This Octave add-on package is part of the Octave-Forge project.

## octave-control 4.1.2

=== debian/changelog ===
octave-control (4.1.2-1) experimental; urgency=medium
  [ Sébastien Villemot ]
  * New upstream version 4.1.2
  * lapack-3.10.0.patch: drop patch, no longer needed

  [ Rafael Laboissière ]
  * d/control: Bump Standards-Version to 4.7.2 (no changes needed)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 22 May 2025 11:12:56 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                dh-octave (>= 1.2.3),
                dh-sequence-octave,
                libslicot-dev (>= 5.8)
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://gnu-octave.github.io/packages/control/
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-control.git
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-control

## octave-control 4.1.3

=== src/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 -include ./Makefile.conf
 
-MKOCTFILE ?= mkoctfile
-
+# the following vars for libs are only defined if mkoctfile is defined
+# and this file might be called without mkoctfile defined (clean, distclean) 
+ifdef MKOCTFILE
 ifndef LAPACK_LIBS
 LAPACK_LIBS := $(shell $(MKOCTFILE) -p LAPACK_LIBS)
 endif
@@ -12,6 +13,7 @@
 FLIBS := $(shell $(MKOCTFILE) -p FLIBS)
 endif
 LDFLAGS := $(shell $(MKOCTFILE) -p LDFLAGS) $(LAPACK_LIBS) $(BLAS_LIBS) $(FLIBS)
+endif
 
 # slicot relative to src directory, SC_SRC is the build directory
 SC      := slicot
@@ -30,8 +32,10 @@
 all: __control_slicot_functions__.oct \
      __control_helper_functions__.oct
 
-# if directly called from repository instead of distributed file structure,
-# copy required files into the slicot source directory.
+# For being able to directly call Makefile from repository instead of
+# distributed file structure, copy required files into the slicot
+# source directory. The file TB01ZD.f is removed afterwards because
+# there is an own version of this file using a different algorithm.
 
 # MA02ID.f : One exemplary file from SLICOT, if not present, other files
 #            are most probably missing as well. Copy all files from the
@@ -40,16 +44,17 @@
 	mkdir -p $(SC_SRC)
 	cp $(SC_SMOD)/src/*.f $(SC_SRC)
 	cp $(SC_SMOD)/src_aux/*.f $(SC_SRC)
+	$(RM) $(SC_SRC)/TB01ZD.f
 	./bootstrap && $(RM) -r "autom4te.cache"
 
 # TODO: Private oct-files for control package.
 
 # Compile SLICOT library
 #
-# Compile: $(SC_SRC)/*.f   (SLICOT files)
-#          ./TG04BX.f      own derived file
-#          $(SRC_AUX)/*.f  external sources like deprecated
-#                          LAPACK files
+# Compile: $(SC_SRC)/*.f                       (SLICOT files, copied above)
+#          $(SRC)/TG04BX.f $(SRC)/TB01ZD.f     own derived files
+#          $(SRC_AUX)/*.f                      external sources like
+#                                              deprecated LAPACK files
 #
 # MA02ID.f is compiled by an extra command
 # suppressing warnings on indexing errors
@@ -57,7 +62,7 @@
 slicotlibrary.a: slicot $(SC_SRC)/MA02ID.f
 	cd $(SC_SRC) && \
 	  $(MKOCTFILE) -w -c MA02ID.f; mv MA02ID.f x && \
-		$(MKOCTFILE) -c *.f $(SRC)/TG04BX.f $(SRC_AUX)/*.f && \
+		$(MKOCTFILE) -c *.f $(SRC)/TB01ZD.f $(SRC)/TG04BX.f $(SRC_AUX)/*.f && \
 		mv x MA02ID.f
 	$(AR) -rc slicotlibrary.a $(SC_SRC)/*.o
 
@@ -81,4 +86,4 @@
 ## remove according to GNU guidelines.
 ## https://www.gnu.org/prep/standards/html_node/Standard-Targets.html
 distclean: clean realclean
-	rm -f Makefile.conf config.h config.log config.status oct-alt-includes.h
+	$(RM) -f Makefile.conf config.h config.log config.status oct-alt-includes.h

=== debian/changelog ===
octave-control (4.1.3-1) unstable; urgency=medium

  * New upstream version 4.1.3
  * d/p/test-tolerances.patch: Drop patch (applied upstream)
  * d/p/use-external-slicot.patch: Refresh for new usptream version
  * d/copyright: Reflect upstream changes
  * d/watch: Convert to version 5
  * d/rules: Remove useless directory /usr/share/octave/packages/control-*/doc/

 -- Rafael Laboissière <rafael@debian.org>  Sat, 13 Sep 2025 04:48:19 -0300

octave-control (4.1.2-2) unstable; urgency=medium

  * test-tolerances.patch: new patch for passing the testsuite on amd64
  * Drop “Rules-Requires-Root: no”, which is now the default

 -- Sébastien Villemot <sebastien@debian.org>  Sun, 10 Aug 2025 17:53:51 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,6 @@
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-control.git
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-control
 Testsuite: autopkgtest-pkg-octave
-Rules-Requires-Root: no
 
 Package: octave-control
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --buildsystem=octave

execute_after_dh_installdeb:
	rm -rf debian/octave-control/usr/share/octave/packages/control-*/doc/

=== debian/watch ===
Version: 5

Source: https://gnu-octave.github.io/packages/control/
Matching-Pattern: https://github.com/gnu-octave/pkg-control/releases/download/control-(?:\d[\-+\.:\~\da-zA-Z]*)/control-@ANY_VERSION@.tar.gz

## octave-control 4.2.1

=== DESCRIPTION ===
Name: control
Version: 4.2.1
Date: 2026-01-20
Author: Lukas Reichlin <lukas.reichlin@gmail.com>
Maintainer: Doug Stewart <doug.dastew@gmail.com>, Torsten Lilge <ttl-octave@mailbox.org>
Title: Control Package
Description: Control package for GNU Octave including system analysis and
 control synthesis. The package uses routines of the SLICOT-Reference library.
Depends: octave (>= 5.2.0)
Autoload: no
License: GPLv3-or-later, BSD 3-Clause License (SLICOT files)
Url: https://github.com/gnu-octave/pkg-control
Tracker: https://github.com/gnu-octave/pkg-control/issues

=== src/Makefile ===
-include ./Makefile.conf

# the following vars for libs are only defined if mkoctfile is defined
# and this file might be called without mkoctfile defined (clean, distclean) 
ifdef MKOCTFILE
	ifndef LAPACK_LIBS
		LAPACK_LIBS := $(shell $(MKOCTFILE) -p LAPACK_LIBS)
	endif
	ifndef BLAS_LIBS
		BLAS_LIBS := $(shell $(MKOCTFILE) -p BLAS_LIBS)
	endif
	ifndef FLIBS
		FLIBS := $(shell $(MKOCTFILE) -p FLIBS)
	endif
	LDFLAGS := $(shell $(MKOCTFILE) -p LDFLAGS) $(LAPACK_LIBS) $(BLAS_LIBS) $(FLIBS)
	# other definitions
	AR := $(shell $(MKOCTFILE) -p AR)
endif

# SLICOT files, relative to src directory
SC        := slicot
SC_SUBMOD := ../slicot-reference
# subdirectories relative to $(SC), $(SC)/$(SC_SRC) is SLICOT build directory
SC_SRC    := src
SC_BUILD  := $(SC)/$(SC_SRC)
# own sources related to SLICOT relative to build directory
SC_LAPACK := lapack_aux
SRC       := ../..

PKG_CXXFLAGS := -Wall $(PKG_CXXFLAGS_APPEND)

all: __control_slicot_functions__.oct \
     __control_helper_functions__.oct

# For being able to directly call Makefile from repository instead of
# distributed file structure, copy required files into the slicot
# source directory. The file TB01ZD.f is removed afterwards because
# there is an own version of this file using a different algorithm.

# MA02ID.f : One exemplary file from SLICOT, if not present, other files
#            are most probably missing as well. Copy all files from the
#            src directories of the SLICOT submodule.
#            If we are in the dist tarball, the *.f files exist already.
$(SC_BUILD)/MA02ID.f:
	mkdir -p $(SC_BUILD)/$(SC_LAPACK)
	cp $(SC_SUBMOD)/$(SC_SRC)/*.f $(SC_BUILD)
	cp $(SC_SUBMOD)/$(SC_SRC)/$(SC_LAPACK)/*.f $(SC_BUILD)/$(SC_LAPACK)
	$(RM) $(SC_BUILD)/TB01ZD.f
	./bootstrap && $(RM) -r "autom4te.cache"

# TODO: Private oct-files for control package.

# Compilation of SLICOT library
#
#   Compile in $(SC_BUILD):  *.f                SLICOT files, copied above
#                            $(SRC)/*.f         own derived files
#                            $(SC_LAPACK)/*.f   deprecated LAPACK files
#
#   MA02ID.f is compiled individually, suppressing indexing warnings
#
slicotlibrary.a: slicot $(SC)/$(SC_SRC)/MA02ID.f
	cd $(SC_BUILD) && \
	  $(MKOCTFILE) -w -c MA02ID.f; mv MA02ID.f x && \
		$(MKOCTFILE) -c *.f $(SRC)/*.f $(SC_LAPACK)/*.f && \
		mv x MA02ID.f
	$(AR) -rc slicotlibrary.a $(SC_BUILD)/*.o

# slicot functions
__control_slicot_functions__.oct: __control_slicot_functions__.cc common.cc slicotlibrary.a
	LDFLAGS='$(LDFLAGS)' \
    $(MKOCTFILE) $(PKG_CXXFLAGS) __control_slicot_functions__.cc common.cc slicotlibrary.a

# helper functions
__control_helper_functions__.oct: __control_helper_functions__.cc
	$(MKOCTFILE) $(PKG_CXXFLAGS) __control_helper_functions__.cc

clean:
	$(RM) -r *.o core octave-core *.oct *~ $(SC_BUILD)/*.o
	$(RM) -rf $(SC_BUILD)

realclean: clean
	$(RM) -r *.a

## This should also remove any configure cache which clean should not
## remove according to GNU guidelines.
## https://www.gnu.org/prep/standards/html_node/Standard-Targets.html
distclean: clean realclean
	$(RM) -f Makefile.conf config.h config.log config.status \
					 oct-alt-includes.h configure aclocal.m4

=== debian/changelog ===
octave-control (4.2.1-3) unstable; urgency=medium

  [ Rafael Laboissière ]
  * d/u/metadata: Add Changelog and Documentation fields

  [ Sébastien Villemot ]
  * test-tolerance.patch: new patch, needed for the testsuite on armhf

 -- Sébastien Villemot <sebastien@debian.org>  Fri, 13 Feb 2026 15:24:42 +0100

octave-control (4.2.1-2) unstable; urgency=medium

  * d/p/use-external-slicot.patch: Adjust patch for using the custom
    version of TB01ZD.f (Closes: #1126261)
  * d/rules: Avoid blhc false positive on output of unit test

 -- Rafael Laboissière <rafael@debian.org>  Sat, 24 Jan 2026 11:36:52 +0000

octave-control (4.2.1-1) unstable; urgency=medium

  * New upstream version 4.2.1
  * d/copyright: Reflect upstream changes
  * d/p/use-external-slicot.patch: Refresh for new upstream version
  * d/rules: Configure the sources before building
  * d/control:
    + Drop the redundant Priority field, which defaults to optional now
    + Bump Standards-Version to 4.7.3

 -- Rafael Laboissière <rafael@debian.org>  Fri, 23 Jan 2026 07:39:38 +0000

octave-control (4.1.3-2) unstable; urgency=medium

  * Rebuild against libslicot5

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 18 Nov 2025 10:08:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: octave-control
 Section: math
-Priority: optional
 Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
 Uploaders: Sébastien Villemot <sebastien@debian.org>,
            Rafael Laboissière <rafael@debian.org>,
@@ -9,7 +8,7 @@
                dh-octave (>= 1.2.3),
                dh-sequence-octave,
                libslicot-dev (>= 5.8)
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://gnu-octave.github.io/packages/control/
 Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-control.git
 Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-control
